_MCU_Init:
;BrushlessARM.c,72 :: 		void MCU_Init()
SUB	SP, SP, #8
STR	LR, [SP, #0]
;BrushlessARM.c,74 :: 		GPIO_Digital_Input (&GPIOD_BASE, _GPIO_PINMASK_3 | _GPIO_PINMASK_6); // configure PORTA pins as input
MOVS	R1, #72
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Input+0
;BrushlessARM.c,75 :: 		GPIO_Digital_Output(&GPIOC_ODR, _GPIO_PINMASK_2);
MOVW	R1, #4
MOVW	R0, #lo_addr(GPIOC_ODR+0)
MOVT	R0, #hi_addr(GPIOC_ODR+0)
BL	_GPIO_Digital_Output+0
;BrushlessARM.c,77 :: 		ADC_Set_Input_Channel(_ADC_CHANNEL_4 | _ADC_CHANNEL_5); // ADC channels 4 and 5
MOVS	R0, #48
BL	_ADC_Set_Input_Channel+0
;BrushlessARM.c,78 :: 		ADC1_Init(); // ADC Init
BL	_ADC1_Init+0
;BrushlessARM.c,79 :: 		Delay_ms(100);
MOVW	R7, #20351
MOVT	R7, #18
NOP
NOP
L_MCU_Init0:
SUBS	R7, R7, #1
BNE	L_MCU_Init0
NOP
NOP
NOP
;BrushlessARM.c,80 :: 		current_speed = 5000; //initial value for current duty
MOVW	R1, #5000
MOVW	R0, #lo_addr(_current_speed+0)
MOVT	R0, #hi_addr(_current_speed+0)
STR	R0, [SP, #4]
STRH	R1, [R0, #0]
;BrushlessARM.c,83 :: 		pwm_period = PWM_TIM5_Init(5000);  // PWM Init on 5kHz
MOVW	R0, #5000
BL	_PWM_TIM5_Init+0
MOVW	R1, #lo_addr(_pwm_period+0)
MOVT	R1, #hi_addr(_pwm_period+0)
STRH	R0, [R1, #0]
;BrushlessARM.c,84 :: 		PWM_TIM5_Set_Duty(current_speed,  _PWM_NON_INVERTED, _PWM_CHANNEL1);
LDR	R0, [SP, #4]
LDRH	R0, [R0, #0]
MOVS	R2, #0
MOVS	R1, #0
BL	_PWM_TIM5_Set_Duty+0
;BrushlessARM.c,85 :: 		PWM_TIM5_Start(_PWM_CHANNEL1, &_GPIO_MODULE_TIM5_CH1_PA0);
MOVW	R1, #lo_addr(__GPIO_MODULE_TIM5_CH1_PA0+0)
MOVT	R1, #hi_addr(__GPIO_MODULE_TIM5_CH1_PA0+0)
MOVS	R0, #0
BL	_PWM_TIM5_Start+0
;BrushlessARM.c,86 :: 		}
L_end_MCU_Init:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _MCU_Init
_DrawFrame:
;BrushlessARM.c,88 :: 		void DrawFrame()
SUB	SP, SP, #4
STR	LR, [SP, #0]
;BrushlessARM.c,90 :: 		TFT_Fill_Screen(CL_TEAL);
MOVW	R0, #1040
BL	_TFT_Fill_Screen+0
;BrushlessARM.c,91 :: 		TFT_Set_Pen(CL_BLACK, 1);
MOVS	R1, #1
MOVW	R0, #0
BL	_TFT_Set_Pen+0
;BrushlessARM.c,92 :: 		TFT_Set_Brush(1,CL_TEAL, 0, 0, CL_TEAL, CL_TEAL);
MOVW	R1, #1040
MOVW	R0, #1040
PUSH	(R1)
PUSH	(R0)
MOVS	R3, #0
MOVS	R2, #0
MOVW	R1, #1040
MOVS	R0, #1
BL	_TFT_Set_Brush+0
ADD	SP, SP, #8
;BrushlessARM.c,93 :: 		TFT_Line(20, 220, 300, 220);
MOVS	R3, #220
SXTH	R3, R3
MOVW	R2, #300
SXTH	R2, R2
MOVS	R1, #220
SXTH	R1, R1
MOVS	R0, #20
SXTH	R0, R0
BL	_TFT_Line+0
;BrushlessARM.c,94 :: 		TFT_Line(20,  46, 300,  46);
MOVS	R3, #46
SXTH	R3, R3
MOVW	R2, #300
SXTH	R2, R2
MOVS	R1, #46
SXTH	R1, R1
MOVS	R0, #20
SXTH	R0, R0
BL	_TFT_Line+0
;BrushlessARM.c,95 :: 		TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_BLACK, FO_HORIZONTAL);
MOVS	R2, #0
MOVW	R1, #0
MOVW	R0, #lo_addr(_HandelGothic_BT21x22_Regular+0)
MOVT	R0, #hi_addr(_HandelGothic_BT21x22_Regular+0)
BL	_TFT_Set_Font+0
;BrushlessARM.c,96 :: 		TFT_Write_Text("Brushless  Click  Board  Example", 12, 14);
MOVW	R0, #lo_addr(?lstr1_BrushlessARM+0)
MOVT	R0, #hi_addr(?lstr1_BrushlessARM+0)
MOVS	R2, #14
MOVS	R1, #12
BL	_TFT_Write_Text+0
;BrushlessARM.c,97 :: 		TFT_Set_Font(&Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL);
MOVS	R2, #0
MOVW	R1, #0
MOVW	R0, #lo_addr(_Verdana12x13_Regular+0)
MOVT	R0, #hi_addr(_Verdana12x13_Regular+0)
BL	_TFT_Set_Font+0
;BrushlessARM.c,98 :: 		TFT_Write_Text("EasyMx PRO v7 for STM32 ARM", 19, 223);
MOVW	R0, #lo_addr(?lstr2_BrushlessARM+0)
MOVT	R0, #hi_addr(?lstr2_BrushlessARM+0)
MOVS	R2, #223
MOVS	R1, #19
BL	_TFT_Write_Text+0
;BrushlessARM.c,99 :: 		TFT_Set_Font(&Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL);
MOVS	R2, #0
MOVW	R1, #0
MOVW	R0, #lo_addr(_Verdana12x13_Regular+0)
MOVT	R0, #hi_addr(_Verdana12x13_Regular+0)
BL	_TFT_Set_Font+0
;BrushlessARM.c,100 :: 		TFT_Write_Text("www.mikroe.com", 200, 223);
MOVW	R0, #lo_addr(?lstr3_BrushlessARM+0)
MOVT	R0, #hi_addr(?lstr3_BrushlessARM+0)
MOVS	R2, #223
MOVS	R1, #200
BL	_TFT_Write_Text+0
;BrushlessARM.c,101 :: 		TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_BLACK, FO_HORIZONTAL);
MOVS	R2, #0
MOVW	R1, #0
MOVW	R0, #lo_addr(_HandelGothic_BT21x22_Regular+0)
MOVT	R0, #hi_addr(_HandelGothic_BT21x22_Regular+0)
BL	_TFT_Set_Font+0
;BrushlessARM.c,102 :: 		TFT_Write_Text("PWM  DUTY", 10, 80 );
MOVW	R0, #lo_addr(?lstr4_BrushlessARM+0)
MOVT	R0, #hi_addr(?lstr4_BrushlessARM+0)
MOVS	R2, #80
MOVS	R1, #10
BL	_TFT_Write_Text+0
;BrushlessARM.c,103 :: 		TFT_Write_Text("PWM  MAX", 10, 140);
MOVW	R0, #lo_addr(?lstr5_BrushlessARM+0)
MOVT	R0, #hi_addr(?lstr5_BrushlessARM+0)
MOVS	R2, #140
MOVS	R1, #10
BL	_TFT_Write_Text+0
;BrushlessARM.c,104 :: 		WordToStr(pwm_period, txt);
MOVW	R0, #lo_addr(_pwm_period+0)
MOVT	R0, #hi_addr(_pwm_period+0)
LDRH	R0, [R0, #0]
MOVW	R1, #lo_addr(_txt+0)
MOVT	R1, #hi_addr(_txt+0)
BL	_WordToStr+0
;BrushlessARM.c,105 :: 		TFT_Write_Text(txt, 150, 140);
MOVS	R2, #140
MOVS	R1, #150
MOVW	R0, #lo_addr(_txt+0)
MOVT	R0, #hi_addr(_txt+0)
BL	_TFT_Write_Text+0
;BrushlessARM.c,106 :: 		TFT_Set_Pen(CL_TEAL, 1);
MOVS	R1, #1
MOVW	R0, #1040
BL	_TFT_Set_Pen+0
;BrushlessARM.c,107 :: 		}
L_end_DrawFrame:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _DrawFrame
_main:
;BrushlessARM.c,109 :: 		void main()
;BrushlessARM.c,111 :: 		MCU_Init();
BL	_MCU_Init+0
;BrushlessARM.c,112 :: 		TFT_Init_ILI9341_8bit(320, 240);  // TFT Init
MOVS	R1, #240
MOVW	R0, #320
BL	_TFT_Init_ILI9341_8bit+0
;BrushlessARM.c,113 :: 		TFT_BLED = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOE_ODR+0)
MOVT	R0, #hi_addr(GPIOE_ODR+0)
STR	R1, [R0, #0]
;BrushlessARM.c,114 :: 		DrawFrame();
BL	_DrawFrame+0
;BrushlessARM.c,116 :: 		MOTOR_DIR = CCW;  // Setting motor direction to counter-clock-wise
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOC_ODR+0)
MOVT	R0, #hi_addr(GPIOC_ODR+0)
STR	R1, [R0, #0]
;BrushlessARM.c,118 :: 		while(1) {
L_main2:
;BrushlessARM.c,120 :: 		if (GPIOD_IDR.B3) {                // button on PD3 pressed
MOVW	R1, #lo_addr(GPIOD_IDR+0)
MOVT	R1, #hi_addr(GPIOD_IDR+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_main4
;BrushlessARM.c,121 :: 		Delay_ms(50);
MOVW	R7, #10175
MOVT	R7, #9
NOP
NOP
L_main5:
SUBS	R7, R7, #1
BNE	L_main5
NOP
NOP
NOP
;BrushlessARM.c,122 :: 		current_speed = current_speed + STEP;   // increment current_duty
MOVW	R2, #lo_addr(_current_speed+0)
MOVT	R2, #hi_addr(_current_speed+0)
LDRH	R0, [R2, #0]
ADDW	R1, R0, #50
UXTH	R1, R1
STRH	R1, [R2, #0]
;BrushlessARM.c,123 :: 		if (current_speed > pwm_period)       // if we increase current_duty greater then possible pwm_period value
MOVW	R0, #lo_addr(_pwm_period+0)
MOVT	R0, #hi_addr(_pwm_period+0)
LDRH	R0, [R0, #0]
CMP	R1, R0
IT	LS
BLS	L_main7
;BrushlessARM.c,125 :: 		current_speed = 0;                    // reset current_duty value to zero
MOVS	R1, #0
MOVW	R0, #lo_addr(_current_speed+0)
MOVT	R0, #hi_addr(_current_speed+0)
STRH	R1, [R0, #0]
;BrushlessARM.c,126 :: 		}
L_main7:
;BrushlessARM.c,127 :: 		PWM_TIM5_Set_Duty(current_speed,  _PWM_NON_INVERTED, _PWM_CHANNEL1);  // set newly acquired duty ratio
MOVW	R0, #lo_addr(_current_speed+0)
MOVT	R0, #hi_addr(_current_speed+0)
LDRH	R0, [R0, #0]
MOVS	R2, #0
MOVS	R1, #0
BL	_PWM_TIM5_Set_Duty+0
;BrushlessARM.c,128 :: 		}
L_main4:
;BrushlessARM.c,130 :: 		if (GPIOD_IDR.B6) {                // button on PD6 pressed
MOVW	R1, #lo_addr(GPIOD_IDR+0)
MOVT	R1, #hi_addr(GPIOD_IDR+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_main8
;BrushlessARM.c,131 :: 		Delay_ms(50);
MOVW	R7, #10175
MOVT	R7, #9
NOP
NOP
L_main9:
SUBS	R7, R7, #1
BNE	L_main9
NOP
NOP
NOP
;BrushlessARM.c,132 :: 		current_speed = current_speed - STEP;
MOVW	R2, #lo_addr(_current_speed+0)
MOVT	R2, #hi_addr(_current_speed+0)
LDRH	R0, [R2, #0]
SUBW	R1, R0, #50
UXTH	R1, R1
STRH	R1, [R2, #0]
;BrushlessARM.c,133 :: 		if (current_speed > pwm_period)       // if we decrease current_duty greater then possible pwm_period value (overflow)
MOVW	R0, #lo_addr(_pwm_period+0)
MOVT	R0, #hi_addr(_pwm_period+0)
LDRH	R0, [R0, #0]
CMP	R1, R0
IT	LS
BLS	L_main11
;BrushlessARM.c,135 :: 		current_speed = pwm_period;          // set current_duty to value of pwm_period
MOVW	R0, #lo_addr(_pwm_period+0)
MOVT	R0, #hi_addr(_pwm_period+0)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_current_speed+0)
MOVT	R0, #hi_addr(_current_speed+0)
STRH	R1, [R0, #0]
;BrushlessARM.c,136 :: 		}
L_main11:
;BrushlessARM.c,137 :: 		PWM_TIM5_Set_Duty(current_speed,  _PWM_NON_INVERTED, _PWM_CHANNEL1); // set newly acquired duty ratio
MOVW	R0, #lo_addr(_current_speed+0)
MOVT	R0, #hi_addr(_current_speed+0)
LDRH	R0, [R0, #0]
MOVS	R2, #0
MOVS	R1, #0
BL	_PWM_TIM5_Set_Duty+0
;BrushlessARM.c,139 :: 		}
L_main8:
;BrushlessARM.c,141 :: 		Delay_ms(20);
MOVW	R7, #43391
MOVT	R7, #3
NOP
NOP
L_main12:
SUBS	R7, R7, #1
BNE	L_main12
NOP
NOP
NOP
;BrushlessARM.c,144 :: 		WordToStr(current_speed, txt);
MOVW	R0, #lo_addr(_current_speed+0)
MOVT	R0, #hi_addr(_current_speed+0)
LDRH	R0, [R0, #0]
MOVW	R1, #lo_addr(_txt+0)
MOVT	R1, #hi_addr(_txt+0)
BL	_WordToStr+0
;BrushlessARM.c,145 :: 		TFT_Rectangle(150, 80, 250, 110);
MOVS	R3, #110
SXTH	R3, R3
MOVS	R2, #250
SXTH	R2, R2
MOVS	R1, #80
SXTH	R1, R1
MOVS	R0, #150
SXTH	R0, R0
BL	_TFT_Rectangle+0
;BrushlessARM.c,146 :: 		TFT_Write_Text(txt, 150, 80);
MOVS	R2, #80
MOVS	R1, #150
MOVW	R0, #lo_addr(_txt+0)
MOVT	R0, #hi_addr(_txt+0)
BL	_TFT_Write_Text+0
;BrushlessARM.c,147 :: 		}
IT	AL
BAL	L_main2
;BrushlessARM.c,149 :: 		}
L_end_main:
L__main_end_loop:
B	L__main_end_loop
; end of _main
